// LockHlprObj.h : Declaration of the CLockHlprObj

#ifndef __LockHlprObj_H_
#define __LockHlprObj_H_

#include "resource.h"       // main symbols
#include "ExDisp.h"
#include "HookExplorer.h"
#include "Shlobj.h"
//#include "LockFold.h"
/////////////////////////////////////////////////////////////////////////////
// CLockHlprObj
class ATL_NO_VTABLE CLockHlprObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CLockHlprObj, &CLSID_LockHlprObj>,
	public IObjectWithSiteImpl<CLockHlprObj>,
//	public CFolder,
	public IDispatchImpl<ILockHlprObj, &IID_ILockHlprObj, &LIBID_LOCKHLPRLib>
{
public:
   DECLARE_REGISTRY_RESOURCEID(IDR_LOCKHLPROBJ)
   DECLARE_NOT_AGGREGATABLE(CLockHlprObj)

   BEGIN_COM_MAP(CLockHlprObj)
	   COM_INTERFACE_ENTRY(ILockHlprObj)
	   COM_INTERFACE_ENTRY(IDispatch)
   	   COM_INTERFACE_ENTRY_IMPL(IObjectWithSite)
//	   COM_INTERFACE_ENTRY_IID(IID_IShellFolder, CFolder)
   END_COM_MAP()



	
// ILockHlprObj
public:
   //
   // CLockHlprObj Methods
   //
   CLockHlprObj();
   ~CLockHlprObj();

   //
   // IDispatch Methods
   //
   STDMETHOD(Invoke)(DISPID dispidMember,REFIID riid, LCID lcid, WORD wFlags,
                     DISPPARAMS * pdispparams, VARIANT * pvarResult,
                     EXCEPINFO * pexcepinfo, UINT * puArgErr);

   //
   // IOleObjectWithSite Methods
   //
	STDMETHOD(SetSite)(IUnknown *pUnkSite);

private:
   CHookExplorer* m_pHookExplorer;

   DWORD m_dwCookie;   // Connection Token - used for Advise and Unadvise
   CComQIPtr<IWebBrowser2, &IID_IWebBrowser2> m_spWebBrowser2;

   enum ConnectType { Advise, Unadvise };   // What to do when managing the connection

   BOOL ManageConnection(enum ConnectType eConnectType);
};

#endif //__LockHlprObj_H_
